<?php

namespace App\Service;

use App\Objects\DirContent;
use App\Objects\UploadedFileData;
use Symfony\Component\DependencyInjection\Attribute\Autowire;
use Symfony\Component\Filesystem\Exception\IOException;
use Symfony\Component\Filesystem\Filesystem;
use Symfony\Component\Finder\Finder;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Symfony\Component\HttpFoundation\RequestStack;

class FileSystemService
{
    public function __construct(
        #[Autowire(env: 'DATA_DIR')]
        private readonly string $dir,
        private readonly Filesystem $filesystem,
    ) {
    }

    /**
     * @return DirContent[]
     */
    public function getDirs(string $dirs): array
    {
        $finder = new Finder();
        $finder->in($this->getTotalPath($dirs));

        $contents = [];

        foreach ($finder->depth(0) as $content) {
            $contents[] = DirContent::make($content);
        }

        return $contents;
    }

    public function uploadFile(UploadedFileData $files): void
    {
        dd($files);
        foreach ($files->files as $file) {
            $this->filesystem->dumpFile($files->dir . $this->getTotalPath($file->getClientOriginalName()), $file->getContent());
        }
    }

    public function isFile(string $dirs): bool
    {
        try {
            $this->filesystem->readFile($this->getTotalPath($dirs));
        } catch (IOException) {
            return false;
        }

        return true;
    }

    public function getFile(string $filePath): DirContent
    {
        $dirs = explode('/', $filePath);
        $fileName = array_pop($dirs);

        $finder = new Finder();
        $finder->in($this->getTotalPath(implode('/', $dirs)));

        foreach ($finder as $file) {
            if ($file->getFilename() === $fileName) {
                return DirContent::make($file, $this->filesystem->readFile($this->getTotalPath($filePath)));
            }
        }

        throw new \RuntimeException('File not found');
    }

    private function getTotalPath(string $filePath): string
    {
        return $this->dir . '/' . $filePath;
    }
}